"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.columnIndex = exports.constantify = exports.maybeRenameHeading = exports.maybeRename = exports.typeify = exports.camelify = exports.hasTable = exports.table = void 0;
const Arr = __importStar(require("fp-ts/Array"));
const F = __importStar(require("fp-ts/function"));
const O = __importStar(require("fp-ts/Option"));
const pluralize_1 = __importDefault(require("pluralize"));
const string_1 = __importDefault(require("string"));
const table = ($el) => $el.nextUntil("h1, h2, h3, h4, h5, h6", "table").first();
exports.table = table;
const hasTable = ($el) => (0, exports.table)($el).length > 0;
exports.hasTable = hasTable;
const camelify = (input) => F.pipe((0, string_1.default)(input).underscore().slugify(), (s) => s.camelize().s);
exports.camelify = camelify;
const typeify = (input, caps = true) => F.pipe((0, string_1.default)(input).underscore().slugify(), (s) => (caps ? s.capitalize() : s), (s) => s.camelize().s, pluralize_1.default.singular);
exports.typeify = typeify;
const fileRemaps = {
    "resources/Guild.md": {
        listActiveThreads: "listGuildActiveThreads",
    },
};
const fileHeadingRemaps = {
    "interactions/Receiving_and_Responding.md": {
        Autocomplete: "InteractionCallbackAutocomplete",
        Message: "InteractionCallbackMessage",
        Modal: "InteractionCallbackModal",
    },
};
const remaps = {
    Allowedmention: "AllowedMention",
    Applicationcommand: "ApplicationCommand",
    Applicationcommandoption: "ApplicationCommandOption",
    Applicationcommandoptionchoice: "ApplicationCommandOptionChoice",
    Applicationcommandoptiontype: "ApplicationCommandOptionType",
    Applicationcommandpermission: "ApplicationCommandPermission",
    Applicationcommandpermissiontype: "ApplicationCommandPermissionType",
    Binary: "string",
    BulkOverwriteGuildApplicationCommandBulkApplicationCommandParams: "BulkOverwriteGuildApplicationCommandParams",
    Connecting: "mixed",
    DocsInteractionsMessageComponent: "Component",
    Filecontent: "string",
    GetGateway: "mixed",
    Guildapplicationcommandpermission: "GuildApplicationCommandPermission",
    InteractionRequestType: "InteractionType",
    ImageDatum: "string",
    Object: "mixed",
    Presence: "PresenceUpdateEvent",
    PresenceUpdate: "PresenceUpdateEvent",
    Messageinteraction: "MessageInteraction",
    UpdatePresenceStatusType: "StatusType",
    TextInputsTextInputStyle: "TextInputStyle",
    MessageComponent: "Component",
    // Gateway commands
    GuildRequestMember: "RequestGuildMember",
    GatewayPresenceUpdate: "UpdatePresence",
    GatewayVoiceStateUpdate: "UpdateVoiceState",
    MessageReactionRemoveEmoji: "MessageReactionRemoveEmojiEvent",
    WebhookUpdateEvent: "WebhooksUpdateEvent",
    // Gateway events
    Hello: "HelloEvent",
};
const maybeRename = (file, heading = false) => (id) => F.pipe(O.fromNullable(fileRemaps[file]?.[id]), O.alt(() => O.fromNullable(remaps[id])), O.getOrElse(() => id), heading ? (0, exports.maybeRenameHeading)(file) : F.identity);
exports.maybeRename = maybeRename;
const maybeRenameHeading = (file) => (id) => F.pipe(O.fromNullable(fileHeadingRemaps[file]?.[id]), O.getOrElse(() => id));
exports.maybeRenameHeading = maybeRenameHeading;
const constantify = (input) => (0, string_1.default)(input.replace(/[^A-z1-9 ]/g, ""))
    .underscore()
    .s.toUpperCase();
exports.constantify = constantify;
const columnIndex = (labels) => {
    const labelsR = new RegExp(`\\b(${labels.join("|")})\\b`, "i");
    return ($) => ($th) => F.pipe($th.map((_, el) => $(el).text()).toArray(), Arr.findIndex((text) => labelsR.test(text)));
};
exports.columnIndex = columnIndex;
