"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.intents = exports.events = exports.fromDocument = void 0;
const Cheerio = __importStar(require("cheerio"));
const F = __importStar(require("fp-ts/function"));
const O = __importStar(require("fp-ts/Option"));
const marked_1 = __importDefault(require("marked"));
const R = __importStar(require("remeda"));
const Common = __importStar(require("./common"));
const Structures = __importStar(require("./structures"));
const fromDocument = ($) => $("h6")
    .toArray()
    .map((h6) => [
    $(h6),
    Common.table($(h6)),
])
    .filter(([$h6]) => /events|commands/i.test($h6.text()))
    .map(([$h6, $table]) => fromHeader($)($h6, $table));
exports.fromDocument = fromDocument;
const fromHeader = ($) => ($h6, $table) => {
    const identifier = Common.typeify($h6.text().trim());
    return {
        identifier,
        values: values($)($table, /event/i.test(identifier)),
    };
};
const values = ($) => ($table, isEvents = false) => {
    const headerCount = $table.find("th").length;
    return F.pipe($table
        .find("td")
        .map((_, td) => $(td))
        .toArray(), R.chunk(headerCount), R.map((columns) => value(columns[0], columns[1], isEvents)));
};
const value = ($name, $description, isEvents) => {
    const name = Common.constantify($name.text().trim());
    const type = Common.typeify($name.text().trim()) + (isEvents ? "Event" : "");
    const description = $description.text().trim();
    return {
        name,
        type,
        description,
    };
};
const events = (markdown) => markdown
    .replace(/\r\n/, "\n")
    .split(/(^|\n)#+\s+/)
    .slice(1)
    .filter(isGatewayEventSection)
    .map((section) => event(section))
    .filter(O.isSome)
    .map((event) => event.value);
exports.events = events;
const eventR = /\b(Inner payload is|The inner payload is)\b/;
const isGatewayEventSection = (section) => eventR.test(section);
const event = (markdown) => {
    const heading = markdown.split("\n")[0].trim();
    return F.pipe(O.fromNullable(/(Inner payload is|The inner payload) .*?[.:\n]/.exec(markdown)), O.map((md) => Cheerio.load(marked_1.default.parse(md[0]))), O.map(($) => $("a")), O.chain(($links) => Structures.referenceFromLinks("")($links)), O.map((ref) => ({
        identifier: Common.typeify(`${heading} Event`),
        payload: ref,
    })));
};
const intents = ($) => $("h3")
    .toArray()
    .map((h3) => [$(h3), $(h3).nextUntil("h3", "pre").first()])
    .filter(([$h3, $pre]) => /list of intents/i.test($h3.text()) && $pre.length > 0)
    .map(([_$h6, $pre]) => ({
    identifier: "GatewayIntents",
    values: intentValuesFromPre($pre),
}));
exports.intents = intents;
const intentValuesFromPre = ($pre) => F.pipe(O.fromNullable($pre.text().matchAll(/\b(\w+)\s+\((\d+) << (\d+)\)/g)), O.map((matches) => [...matches]), O.fold(() => [], (matches) => matches.map(([_, name, left, right]) => ({
    name,
    description: O.none,
    bigint: false,
    left,
    right,
}))));
