import * as Cheerio from "cheerio";
import * as O from "fp-ts/Option";
export declare const excludeR: RegExp;
export declare const fromDocument: ($: Cheerio.CheerioAPI, { file, exclude, include, }: {
    exclude?: RegExp | undefined;
    include?: RegExp | undefined;
    file?: string | undefined;
}) => Structure[];
export declare const fromHeader: ($: Cheerio.CheerioAPI, file: string) => ($h6: Cheerio.Cheerio<Cheerio.Element>, $table: Cheerio.Cheerio<Cheerio.Element>) => {
    identifier: string;
    fields: {
        name: string;
        optional: boolean;
        type: {
            identifier: string;
            nullable: boolean;
            array: boolean;
            snowflakeMap: boolean;
        };
        description: string;
    }[];
};
export declare type Structure = ReturnType<ReturnType<typeof fromHeader>>;
export declare const identifier: (file: string, isHeading?: boolean) => (heading: string) => string;
export declare const fields: ($: Cheerio.CheerioAPI, file: string) => ($table: Cheerio.Cheerio<Cheerio.Element>) => {
    name: string;
    optional: boolean;
    type: {
        identifier: string;
        nullable: boolean;
        array: boolean;
        snowflakeMap: boolean;
    };
    description: string;
}[];
export declare const field: (file: string) => ($name: Cheerio.Cheerio<Cheerio.Element>, $type: Cheerio.Cheerio<Cheerio.Element>, $description: Cheerio.Cheerio<Cheerio.Element>) => {
    name: string;
    optional: boolean;
    type: {
        identifier: string;
        nullable: boolean;
        array: boolean;
        snowflakeMap: boolean;
    };
    description: string;
};
export declare const type: (file: string) => ($type: Cheerio.Cheerio<Cheerio.Element>, $description: Cheerio.Cheerio<Cheerio.Element>) => {
    identifier: string;
    nullable: boolean;
    array: boolean;
    snowflakeMap: boolean;
};
export declare const referenceFromLinks: (file: string) => ($links: Cheerio.Cheerio<Cheerio.Element>, includeStructures?: boolean) => O.Option<string>;
export declare const referencesFromLinks: ($: Cheerio.CheerioAPI, file: string) => ($links: Cheerio.Cheerio<Cheerio.Element>, includeStructures?: boolean) => string[];
export declare const referenceFromLink: (file: string) => ($link: Cheerio.Cheerio<Cheerio.Element>, includeStructures?: boolean) => O.Option<string>;
export declare const identifierOrReference: (file: string) => (identifier: string, relation: O.Option<string>, $description: Cheerio.Cheerio<Cheerio.Element>) => string;
